
#include <windows.h>
#include "avisynth.h"
#include <stdio.h> // debug messages

static __inline int ScaledValue(int i) {
  return (i+256)>>9;
}

class HSVAdjust : public GenericVideoFilter
{
public:
  HSVAdjust( PClip _child, double _hue, double _sat, double _bright, double _cont, const char* __brightness,
					   IScriptEnvironment* env );

  PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);

  static AVSValue __cdecl Create(AVSValue args, void* user_data, IScriptEnvironment* env);
  static AVSValue __cdecl CreateHSL(AVSValue args, void* user_data, IScriptEnvironment* env);

private:
  int Sat, Bright, Cont, Hue;

  int mapH[256*2][256];
  int mapS[256][256];
  int mapfHi[256*6];
  int channels;

  int brightness;
  enum {value = 0, lightness};
};



class HSIAdjust : public GenericVideoFilter
{
public:
  HSIAdjust( PClip _child, double _hue, double _sat, double _bright, double _cont, IScriptEnvironment* env );

  PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);

  static AVSValue __cdecl Create(AVSValue args, void* user_data, IScriptEnvironment* env);

private:
  int Sat, Bright, Cont, Hue;

  int mapH[256][256];
  int mapfHi[256*6];
  int mapI[256*4];
  int channels;
  int coef;
};
